package main

import (
	"bufio"
	"fmt"
	"io"
	"net"
	"strconv"
	"strings"
	"time"
)

func response1(conn net.Conn) {
	defer conn.Close()

	n, err := conn.Write([]byte(time.Now().Format("2006-01-02 15:04:06")))
	if err != nil {
		fmt.Println(err.Error())
		return
	}
	fmt.Println("sent to client", conn.RemoteAddr(), n, "bytes.")
}

func response2(conn net.Conn) {
	defer conn.Close()
	var err error
	var n int
	bs := make([]byte, 1024)

	for {
		n, err = conn.Read(bs)
		if err != nil {
			fmt.Println()
			return
		}
		req := strings.Join([]string{"receive from", conn.RemoteAddr().String(), "data is", string(bs[:n]), ",len is", strconv.Itoa(n), "bytes."}, " ")
		fmt.Println(req)

		resp := strings.Join([]string{time.Now().Format("2006-01-02 15:04:06"), req}, " ")
		n, err = conn.Write([]byte(resp))
		if err != nil {
			fmt.Println(err.Error())
			return
		}
		fmt.Println("sent to client", conn.RemoteAddr(), n, "bytes.")
	}
}

func response3(conn net.Conn) {
	defer conn.Close()
	defer func() {
		fmt.Println("conn", conn.RemoteAddr(), "is closed.")
	}()

	reader := bufio.NewReader(conn)
	writer := bufio.NewWriter(conn)

	for {
		_, err := writer.WriteString(fmt.Sprintf("client from %s\n", conn.RemoteAddr().String()))
		if err != nil {
			fmt.Println(err.Error())
		}
		_ = writer.Flush()

		str, err := reader.ReadString('\n')
		if err != nil {
			fmt.Println(err.Error())
			if err == io.EOF {
				break
			}
			return
		}
		fmt.Printf("receive from %s, data is %s.\n", conn.RemoteAddr(), str)
	}

}

func main() {
	addr := "0.0.0.0:8888" // ":8888"
	var err error

	listen, err := net.Listen("tcp", addr)
	if err != nil {
		fmt.Println(err.Error())
		return
	}
	defer listen.Close()
	fmt.Println("listen on", addr)

	for {
		// 等待客户端连接
		conn, err := listen.Accept()
		if err != nil {
			return
		}

		//go response1(conn)
		//go response2(conn)
		go response3(conn)
	}
}
